import random

import max_product_naive
import max_product_fast


def test(repeats, N, M):
    # N - total number of list elements
    # M - each element is random number from 0 to M
    ok_count = 0
    for i in range(repeats):
        list_size = random.randint(2, N)
        lst = []
        for j in range(list_size):
            x = random.randint(0, M)
            lst.append(x)

        sol_naive = max_product_naive.max_product(lst)
        sol_linear = max_product_fast.max_product(lst)

        if sol_naive == sol_linear:
            ok_count += 1
        else:
            print("Error after {} iterations: for input {} linear produced {}, "
                  "naive produced {}".format(ok_count, lst, sol_linear, sol_naive))
            return

    print("All {} tests passed.".format(ok_count))

if __name__ == "__main__":
    test(1000, 1000, 5)
